atkmm: Atk::Component Class Reference

atkmm 2.28.5

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Atk::Component Class Reference

The ATK interface provided by UI components which occupy a physical area on the screen. More...

`#include <atkmm/component.h>`

Inheritance diagram for Atk::Component:
[legend]

## Public Member Functions
| Component (Component && src) noexcept
Component & | operator= (Component && src) noexcept
| ~Component () noexcept override
AtkComponent * | gobj ()
| Provides access to the underlying C GObject.
const AtkComponent * | gobj () const
| Provides access to the underlying C GObject.
guint | add_focus_handler (AtkFocusHandler handler)
| Add the specified handler to the set of functions to be called when this object receives focus events (in or out).
bool | contains (int x, int y, CoordType coord_type) const
| Checks whether the specified point is within the extent of the component.
Glib::RefPtr< Atk::Object > | get_accessible_at_point (int x, int y, CoordType coord_type)
| Gets a reference to the accessible child, if one exists, at the coordinate point specified by x and y.
void | get_extents (int & x, int & y, int & width, int & height, CoordType coord_type) const
| Gets the rectangle which gives the extent of the component.
void | get_position (int & x, int & y, CoordType coord_type) const
| Gets the position of component in the form of a point specifying component's top-left corner.
void | get_size (int & width, int & height) const
| Gets the size of the component in terms of width and height.
Layer | get_layer () const
| Gets the layer of the component.
int | get_mdi_zorder () const
| Gets the zorder of the component.
bool | grab_focus ()
| Grabs focus for this component.
void | remove_focus_handler (guint handler_id)
| Remove the handler specified by handler_id from the list of functions to be executed when this object receives focus events (in or out).
bool | set_extents (int x, int y, int width, int height, CoordType coord_type)
| Sets the extents of component.
bool | set_position (int x, int y, CoordType coord_type)
| Sets the postition of component.
bool | set_size (int width, int height)
| Set the size of the component in terms of width and height.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| Component ()
| You should derive from this class to use it.
virtual guint | add_focus_handler_vfunc (AtkFocusHandler handler)
virtual bool | contains_vfunc (int x, int y, CoordType coord_type) const
virtual Glib::RefPtr< Atk::Object > | get_accessible_at_point_vfunc (int x, int y, CoordType coord_type)
virtual void | get_extents_vfunc (int & x, int & y, int & width, int & height, CoordType coord_type) const
virtual void | get_position_vfunc (int & x, int & y, CoordType coord_type) const
virtual void | get_size_vfunc (int & width, int & height) const
virtual Layer | get_layer_vfunc () const
virtual int | get_mdi_zorder_vfunc () const
virtual bool | grab_focus_vfunc ()
virtual void | remove_focus_handler_vfunc (guint handler_id)
virtual bool | set_extents_vfunc (int x, int y, int width, int height, CoordType coord_type)
virtual bool | set_position_vfunc (int x, int y, CoordType coord_type)
virtual bool | set_size_vfunc (int width, int height)
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Atk::Component > | wrap (AtkComponent * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

The ATK interface provided by UI components which occupy a physical area on the screen.

This should be implemented by most if not all UI elements with an actual on-screen presence, i.e. components which can be said to have a screen-coordinate bounding box. Virtually all widgets will need to have Atk::Component implementations provided for their corresponding Atk::Object class. In short, only UI elements which are not GUI elements will omit this ATK interface.

A possible exception might be textual information with a transparent background, in which case text glyph bounding box information is provided by Atk::Text.

## Constructor & Destructor Documentation

## ◆ Component() [1/2]

Atk::Component::Component | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ Component() [2/2]

Atk::Component::Component | ( | Component && | src | ) |
| noexcept

## ◆ ~Component()

Atk::Component::~Component | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_focus_handler()

guint Atk::Component::add_focus_handler | ( | AtkFocusHandler | handler | ) |

Add the specified handler to the set of functions to be called when this object receives focus events (in or out).

If the handler is already added it is not added again

Deprecated: 2.9.4: If you need to track when an object gains or lose the focus, use the Atk::Object::signal_state_change() "focused" notification instead.

Deprecated
  If you need to track when an object gains or lose the focus, use Atk::Object::signal_state_change() and check for focused notification instead.

Parameters

  handler | The Atk::FocusHandler to be attached to component.

Returns
  A handler id which can be used in remove_focus_handler() or zero if the handler was already added.

## ◆ add_focus_handler_vfunc()

virtual guint Atk::Component::add_focus_handler_vfunc | ( | AtkFocusHandler | handler | ) |
| protectedvirtual

## ◆ add_interface()

void Atk::Component::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ contains()

bool Atk::Component::contains | ( | int | x,
|  | int | y,
|  | CoordType | coord_type ) const

Checks whether the specified point is within the extent of the component.

Toolkit implementor note: ATK provides a default implementation for this virtual method. In general there are little reason to re-implement it.

Parameters

  x | X coordinate.
  y | Y coordinate.
  coord_type | Specifies whether the coordinates are relative to the screen or to the components top level window.

Returns
  true or false indicating whether the specified point is within the extent of the component or not.

## ◆ contains_vfunc()

virtual bool Atk::Component::contains_vfunc | ( | int | x,
|  | int | y,
|  | CoordType | coord_type ) const
| protectedvirtual

## ◆ get_accessible_at_point()

Glib::RefPtr< Atk::Object > Atk::Component::get_accessible_at_point | ( | int | x,
|  | int | y,
|  | CoordType | coord_type )

Gets a reference to the accessible child, if one exists, at the coordinate point specified by x and y.

Parameters

  x | X coordinate.
  y | Y coordinate.
  coord_type | Specifies whether the coordinates are relative to the screen or to the components top level window.

Returns
  A reference to the accessible child, if one exists.

## ◆ get_accessible_at_point_vfunc()

virtual Glib::RefPtr< Atk::Object > Atk::Component::get_accessible_at_point_vfunc | ( | int | x,
|  | int | y,
|  | CoordType | coord_type )
| protectedvirtual

## ◆ get_extents()

void Atk::Component::get_extents | ( | int & | x,
|  | int & | y,
|  | int & | width,
|  | int & | height,
|  | CoordType | coord_type ) const

Gets the rectangle which gives the extent of the component.

Parameters

  x | Address of int to put x coordinate.
  y | Address of int to put y coordinate.
  width | Address of int to put width.
  height | Address of int to put height.
  coord_type | Specifies whether the coordinates are relative to the screen or to the components top level window.

## ◆ get_extents_vfunc()

virtual void Atk::Component::get_extents_vfunc | ( | int & | x,
|  | int & | y,
|  | int & | width,
|  | int & | height,
|  | CoordType | coord_type ) const
| protectedvirtual

## ◆ get_layer()

Layer Atk::Component::get_layer | ( |  | ) | const

Gets the layer of the component.

Returns
  An Atk::Layer which is the layer of the component.

## ◆ get_layer_vfunc()

virtual Layer Atk::Component::get_layer_vfunc | ( |  | ) | const
| protectedvirtual

## ◆ get_mdi_zorder()

int Atk::Component::get_mdi_zorder | ( |  | ) | const

Gets the zorder of the component.

The value G_MININT will be returned if the layer of the component is not ATK_LAYER_MDI or ATK_LAYER_WINDOW.

Returns
  A int which is the zorder of the component, i.e. the depth at which the component is shown in relation to other components in the same container.

## ◆ get_mdi_zorder_vfunc()

virtual int Atk::Component::get_mdi_zorder_vfunc | ( |  | ) | const
| protectedvirtual

## ◆ get_position()

void Atk::Component::get_position | ( | int & | x,
|  | int & | y,
|  | CoordType | coord_type ) const

Gets the position of component in the form of a point specifying component's top-left corner.

Deprecated: Since 2.12. Use get_extents() instead.

Deprecated
  Use get_extents() instead.

Parameters

  x | Address of int to put x coordinate position.
  y | Address of int to put y coordinate position.
  coord_type | Specifies whether the coordinates are relative to the screen or to the components top level window.

## ◆ get_position_vfunc()

virtual void Atk::Component::get_position_vfunc | ( | int & | x,
|  | int & | y,
|  | CoordType | coord_type ) const
| protectedvirtual

## ◆ get_size()

void Atk::Component::get_size | ( | int & | width,
|  | int & | height ) const

Gets the size of the component in terms of width and height.

Deprecated: Since 2.12. Use get_extents() instead.

Deprecated
  Use get_extents() instead.

Parameters

  width | Address of int to put width of component.
  height | Address of int to put height of component.

## ◆ get_size_vfunc()

virtual void Atk::Component::get_size_vfunc | ( | int & | width,
|  | int & | height ) const
| protectedvirtual

## ◆ get_type()

GType Atk::Component::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

AtkComponent * Atk::Component::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const AtkComponent * Atk::Component::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ grab_focus()

bool Atk::Component::grab_focus | ( |  | ) |

Grabs focus for this component.

Returns
  true if successful, false otherwise.

## ◆ grab_focus_vfunc()

virtual bool Atk::Component::grab_focus_vfunc | ( |  | ) |
| protectedvirtual

## ◆ operator=()

Component & Atk::Component::operator= | ( | Component && | src | ) |
| noexcept

## ◆ remove_focus_handler()

void Atk::Component::remove_focus_handler | ( | guint | handler_id | ) |

Remove the handler specified by handler_id from the list of functions to be executed when this object receives focus events (in or out).

Deprecated: 2.9.4: If you need to track when an object gains or lose the focus, use the Atk::Object::signal_state_change() "focused" notification instead.

Deprecated
  If you need to track when an object gains or lose the focus, use Atk::Object::signal_state_change() and check for focused notification instead.

Parameters

  handler_id | The handler id of the focus handler to be removed from component.

## ◆ remove_focus_handler_vfunc()

virtual void Atk::Component::remove_focus_handler_vfunc | ( | guint | handler_id | ) |
| protectedvirtual

## ◆ set_extents()

bool Atk::Component::set_extents | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | CoordType | coord_type )

Sets the extents of component.

Parameters

  x | X coordinate.
  y | Y coordinate.
  width | Width to set for component.
  height | Height to set for component.
  coord_type | Specifies whether the coordinates are relative to the screen or to the components top level window.

Returns
  true or false whether the extents were set or not.

## ◆ set_extents_vfunc()

virtual bool Atk::Component::set_extents_vfunc | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | CoordType | coord_type )
| protectedvirtual

## ◆ set_position()

bool Atk::Component::set_position | ( | int | x,
|  | int | y,
|  | CoordType | coord_type )

Sets the postition of component.

Parameters

  x | X coordinate.
  y | Y coordinate.
  coord_type | Specifies whether the coordinates are relative to the screen or to the components top level window.

Returns
  true or false whether or not the position was set or not.

## ◆ set_position_vfunc()

virtual bool Atk::Component::set_position_vfunc | ( | int | x,
|  | int | y,
|  | CoordType | coord_type )
| protectedvirtual

## ◆ set_size()

bool Atk::Component::set_size | ( | int | width,
|  | int | height )

Set the size of the component in terms of width and height.

Parameters

  width | Width to set for component.
  height | Height to set for component.

Returns
  true or false whether the size was set or not.

## ◆ set_size_vfunc()

virtual bool Atk::Component::set_size_vfunc | ( | int | width,
|  | int | height )
| protectedvirtual

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Atk::Component > wrap | ( | AtkComponent * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.